/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.net.mixin.impl;

import java.util.List;
import java.util.stream.Collectors;
import net.minecraft.class_1923;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_3193;
import net.minecraft.class_3222;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.LocalCapture;
import alexiil.mc.lib.net.mixin.api.IBlockEntityInitialData;

@Mixin(class_3193.class)
public abstract class ChunkHolderMixin {

    private static final String WORLD = "Lnet/minecraft/world/World;";
    private static final String BLOCK_POS = "Lnet/minecraft/util/math/BlockPos;";
    private static final String BLOCK_ENTITY = "Lnet/minecraft/block/entity/BlockEntity;";

    @Shadow
    private class_3193.class_3897 playersWatchingChunkProvider;

    @Shadow
    private class_1923 pos;

    @Inject(at = @At(value = "INVOKE_ASSIGN", target = WORLD + "getBlockEntity(" + BLOCK_POS + ")" + BLOCK_ENTITY),
        method = "sendBlockEntityUpdatePacket(" + WORLD + BLOCK_POS + ")V", locals = LocalCapture.CAPTURE_FAILHARD)
    void sendCustomUpdatePacket(class_1937 world, class_2338 pos, CallbackInfo ci, class_2586 be) {

        if (be instanceof IBlockEntityInitialData) {
            List<class_3222> players
                = playersWatchingChunkProvider.method_17210(this.pos, false).collect(Collectors.toList());
            for (class_3222 player : players) {
                ((IBlockEntityInitialData) be).sendInitialData(player);
            }
        }
    }
}
