/*
 * Copyright (c) 2019 AlexIIL
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */
package alexiil.mc.lib.net.mixin.impl;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import alexiil.mc.lib.net.mixin.api.IBlockEntityInitialData;
import net.minecraft.class_2586;
import net.minecraft.class_2596;
import net.minecraft.class_2818;
import net.minecraft.class_3222;
import net.minecraft.class_3898;

@Mixin(class_3898.class)
public abstract class ThreadedAnvilChunkStorageMixin {

    @Inject(at = @At("RETURN"), method = "sendChunkDataPackets(Lnet/minecraft/server/network/ServerPlayerEntity;"
        + "[Lnet/minecraft/network/Packet;Lnet/minecraft/world/chunk/WorldChunk;)V")
    private void postSendPackets(class_3222 player, class_2596<?>[] packets, class_2818 chunk, CallbackInfo ci) {
        for (class_2586 be : chunk.method_12214().values()) {
            if (be instanceof IBlockEntityInitialData) {
                ((IBlockEntityInitialData) be).sendInitialData(player);
            }
        }
    }
}
